CON                    
  _clkmode = xtal1 + pll16x 
  _xinfreq = 5_000_000

  CSpin      = 0  
  CLKpin     = 1  
  DATApin    = 2  

  ARRAYS_IN_USE = 5             '' User changeable   

VAR
  long scrollDelay
  long scrollInterval, oneMS   
  byte arrayBuffer[Arrays_In_Use * LEDS#LINES_IN_ARRAY]
  byte brightness

  long useser           'USB serial connection detected T/F

OBJ
  LEDS         : "LEDarray" 
' LEDS         : "LEDarray3"             'uses    Duane's SyncScrollTime and NextScrollTime
  Debug        : "Extended_FDSerial"   

PUB Setup
  oneMs := clkfreq / 1000   

  useser := false
  if ina[31] == 1                      ' RX (pin 31) is high if USB is connected
    Debug.start(31, 30, 0, 57600)      ' ignore tx echo on rx
    useser := true                     ' Debug serial connection is active 
    waitcnt(clkfreq * 2 + cnt)         ' time to open debug terminal
  
  if useser
    debug.str(String("Clock Freq: "))
    debug.dec(clkfreq)
    debug.tx(13) 
    scrollInterval := Leds#DEFAULT_SCROLL_INTERVAL * oneMs
    debug.str(String("scroll interval: "))
    debug.dec(scrollInterval)
    debug.tx(13)
    
  Leds.Init(CLKpin, DATApin, CSpin, ARRAYS_IN_USE, @arrayBuffer)

'' Set brightness and delay in child object.
  brightness := Leds.SetBrightness(Leds#DEFAULT_BRIGHTNESS)
'  scrollDelay := Leds.SetScrollDelay(Leds#DEFAULT_SCROLL_INTERVAL / 2)
  
  MainLoop

PUB MainLoop

  Leds.LoadBitsToArray(@arrayBuffer)

  Leds.ScrollMsg(string("Scrolling text example "))
  Leds.BlankAll
  Leds.SetFont(Leds#ASCII_0508)
  Leds.ShiftMsg(string("Shifting text one char at a time"))

  Leds.SetFont(Leds#FREE_DESIGN)  
'  Leds.ScrollMsg(@message0)
  Leds.AllChar

  Leds.BlankAll

  scrollDelay := Leds.SetScrollDelay(Leds#DEFAULT_SCROLL_INTERVAL / 2)
  Leds.SetFont(Leds#ASCII_0508)  
'  Leds.ScrollMsg(@message0)
  Leds.AllChar

  Leds.BlankAll
 
PRI Prompt(msg, CR)
  Debug.str(msg)
  if CR
    Debug.tx(13)  

DAT
'message0                byte "    Merry Christmas",0
message0                byte "Pippin the dog!     ", 0
message1                byte "Merry Christmas!    ", 0  